Subject: Re: [PATCH v5 next 1/5] modules:capabilities: add request_module_cap()

From: Alan Cox <[email-masked]>
Date: Wed, 29 Nov 2017 13:46:12 +0000

On Tue, 28 Nov 2017 13:39:58 -0800
Kees Cook <[email-masked]> wrote:

> On Tue, Nov 28, 2017 at 1:16 PM, Luis R. Rodriguez <[email-masked]> wrote:
> > And *all* auto-loading uses aliases? What's the difference between auto-loading
> > and direct-loading?  
> 
> The difference is the process privileges. Unprivilged autoloading
> (e.g. int n_hdlc = N_HDLC; ioctl(fd,
> TIOCSETD, &n_hdlc)), triggers a privileged call to finit_module()
> under CAP_SYS_MODULE.

If you have CAP_SYS_DAC you can rename any module to ppp.ko and ask the
network manager (which has the right permissions) to init a ppp
connection. Capabilities alone are simply not enough to do any kind of
useful protection on a current system and the Linux capability model is
broken architecturally and not fixable because fixing it would break lots
of real systems.

I really don't care what the module loading rules end up with and whether
we add CAP_SYS_YET_ANOTHER_MEANINGLESS_FLAG but what is actually needed
is to properly incorporate it into securiy ruiles for whatever LSM you
are using.

Alan